Attribute VB_Name = "modBinAccess"
Public Char As Byte
Public Char16 As Word
Public Char32 As DoubleWord
Public Char64 As QuadWord
Public Char128 As OctalWord

Public CurrentFileName As String
Public SaveFileName As String
' 16 Bits
Type Word
    lByte As Byte
    hByte As Byte
End Type

' 2 Words or 32 Bits
Type DoubleWord
    LowWord As Word
    HighWord As Word
End Type

' 3 DoubleWords or 64 Bits
Type QuadWord
    LowDword As DoubleWord
    HighDword As DoubleWord
End Type

' 128 Bits
Type OctalWord
    LowDword As QuadWord
    HighDword As QuadWord
End Type

' Each Sub allows open and save from 8 bits to 128 bits.
' All subs are the same except for the amount of bits
Public Sub SaveBin8()
Dim Pos As Long ' Position Counter in the two files

Open CurrentFileName For Binary As #1 ' File name to copy
    Open SaveFileName For Binary As #2 ' File name to save
    ' Read #1 and Write #2 in a loop
    Do While Not EOF(1)
    Pos = Pos + 1
    Get #1, Pos, Char   ' char type is how big the access is
    Put #2, Pos, Char
    Loop
    Close #1
    Close #2
    MsgBox "Done"
   
End Sub

Public Sub SaveBin16()
Dim Pos As Long
Pos = -1
Open CurrentFileName For Binary As #1
    Open SaveFileName For Binary As #2
    Do While Not EOF(1)
    Pos = Pos + 2
    Get #1, Pos, Char16
    Put #2, Pos, Char16
    Loop
    Close #1
    Close #2
    MsgBox "Done"
   
End Sub

Public Sub SaveBin32()
Dim Pos As Long
Pos = -3
Open CurrentFileName For Binary As #1
    Open SaveFileName For Binary As #2
    Do While Not EOF(1)
    Pos = Pos + 4
    Get #1, Pos, Char32
    Put #2, Pos, Char32
    Loop
    Close #1
    Close #2
    MsgBox "Done"
   
End Sub


Public Sub SaveBin64()
Dim Pos As Long
Pos = -7
Open CurrentFileName For Binary As #1
    Open SaveFileName For Binary As #2
    Do While Not EOF(1)
    Pos = Pos + 8
    Get #1, Pos, Char64
    Put #2, Pos, Char64
    Loop
    Close #1
    Close #2
    MsgBox "Done"
   
End Sub
Public Sub SaveBin128()
Dim Pos As Long
Pos = -15
Open CurrentFileName For Binary As #1
    Open SaveFileName For Binary As #2
    Do While Not EOF(1)
    Pos = Pos + 16
    Get #1, Pos, Char128
    Put #2, Pos, Char128
    Loop
    Close #1
    Close #2
    MsgBox "Done"
   
End Sub

Public Sub OpenFile(vForm As Form)
' Handle errors
    On Error GoTo OpenProblem
    ' Set wildcard patterns and make *.luf the default
    ' luf extension for Launcher URL File
    vForm.CommonDialog1.InitDir = App.Path
    vForm.CommonDialog1.Filter = "ALL Files(*.*|*.*"
    vForm.CommonDialog1.FilterIndex = 1
    ' Display an Open dialog box.
    vForm.CommonDialog1.Action = 1
    
    ' vForm.Caption = strAppName & " - " & vForm.CommonDialog1.FileName
    ' vForm.Caption = strAppName & " - " & vForm.CommonDialog1.FileName
    CurrentFileName = vForm.CommonDialog1.FileName
    Exit Sub
OpenProblem:
    ' Cancel button clicked
    Exit Sub

End Sub
Public Sub SaveFile(vForm As Form)
On Error GoTo SaveERR
    Dim FileNum As Integer
    ' Set Initial Directory to open and FileTypes
        vForm.CommonDialog1.InitDir = App.Path
        vForm.CommonDialog1.Filter = "ALL Files | *.*"
        
        SaveFileName = CurrentFileName ' FileString(frmMain.lstFiles.ListIndex + 1)
        If SaveFileName = "" Then
            vForm.CommonDialog1.FileName = "" ' FileString(frmMain.lstFiles.ListIndex)
        Else
            vForm.CommonDialog1.FileName = SaveFileName
        End If
        
            vForm.CommonDialog1.ShowSave
            SaveFileName = vForm.CommonDialog1.FileName
Exit Sub
SaveERR:
        ' I don't know what the error was, but I want to let you know and then
        ' Exit the sub.
End Sub

Public Sub OpenAbout()
frmStore.Show
Open App.Path & "\Readme.txt" For Input As #1
    frmStore.txtStore.Text = Input$(LOF(1), 1)
    Close #1
End Sub


